/*
 * FiveNotes.java
 * FiveNotes -  Pentatonic nervous breakdown
 * Author: Akio MIWA, 2002-.
 */

import com.nttdocomo.io.ConnectionException;
import com.nttdocomo.ui.Canvas;
import com.nttdocomo.ui.Dialog;
import com.nttdocomo.ui.Display;
import com.nttdocomo.ui.Font;
import com.nttdocomo.ui.Frame;
import com.nttdocomo.ui.Graphics;
import com.nttdocomo.ui.IApplication;
import com.nttdocomo.ui.Image;
import com.nttdocomo.ui.MediaImage;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.UIException;
import java.util.Date;      // Ԋ֘Å֐`ĂBJDK1.0.2
import java.util.Random;

public class FiveNotes extends IApplication {
   MainCanvas mc;
   public void start() {
//    long yearInMillis = 31536000000L;
//    long  dayInMillis =    86400000L;
      // 2002-6-6 gp̓ƂB
   // Date     LimitTime = new Date(31536000000L * (2002 -1970) +
   //                                  86400000L * 200);
      // 2003-1-1 gp̓ƂB
      Date     LimitTime = new Date(31536000000L * (2003 -1970) +
                                       86400000L * 1);

/*
      Calendar cal       = Calendar.getInstance();
      cal.setTime(LimitTime);
      System.out.println(cal.get(Calendar.YEAR));
      System.out.println(cal.get(Calendar.MONTH));
      System.out.println(cal.get(Calendar.DAY_OF_WEEK));
 */
      // Ԃ𒴂Ă邩`FbN
      // ݒzĂꍇ́CI
      if (System.currentTimeMillis() >= LimitTime.getTime()) {
         IApplication.getCurrentApp().terminate();
  //     System.out.println("Time over");
  //  } else {
  //     System.out.println("Before Time");
      }

      mc = new MainCanvas(120, 120);
      Display.setCurrent(mc);
   }
}

class MainCanvas extends Canvas {

   final static boolean DOCOMO_EMU = false;
// final static boolean DOCOMO_EMU = true;

   String VERSION = "1.0.0";
   private static Random       rnd;

   int     TitleFlag = 0;
   int     rows    = 4;  // row s
   int     columns = 3;  // columnc̗
   Card    cards[];
   int     CardStatus[] = { -1, -1 };
                            // ݁C\ɂȂĂJ[hID
                            // -1   J[h́CJĂȂB
   long    StartTime;       // oߎԂ̌vp
final static int card_width  = 30;
final static int card_height = 24;

final static int offsetX = 15;
final static int offsetY =  0;


// for Game status
final static int OVER  = -1;
final static int PLAY  =  0;
final static int CLEAR =  1;

// g.setColor(Graphics.getColorOfRGB(  0,  0,255)); /** Blue */
// g.setColor(Graphics.getColorOfRGB(255,  0,  0)); /** Red */
// g.setColor(Graphics.getColorOfRGB(255,255,  0)); /** Yellow */
// g.setColor(Graphics.getColorOfRGB(  0,255,  0)); /** Green */
// g.setColor(Graphics.getColorOfRGB(  0,  0,  0)); /** Black */
// g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */

   static  Dialog dialog;

   private Image imageTitle;
   private Image imageQuistion;
   private Image imageNote;

   MediaImage mimageTitle;
   MediaImage mimageQuestion;
   MediaImage mimageNote;

   String      message = "Are you ready?";

   boolean     runStatus = false;   // stO

   int  PairCount = 0;      // NAJ[h̃JE^
   int  TryCount  = 0;      // s񐔃JE^

   int  width  = 120;
   int  height = 120;


   void msg(String msg) {
      this.message = msg;
   }

   void resetCards() {
      // cardĔzuB
      for (int i = 0; i < rows * columns; i++) {
            cards[i].reset();  // JĂȂcardtO
            cards[i].setNote(i % 6);
      }
      int n1, n2;
      int p1, p2;
      // J[h_ɓւāCԂƂB
      for (int i = 0; i < 256; i++) {
         p1 = Math.abs(rnd.nextInt() % (rows * columns));
         p2 = Math.abs(rnd.nextInt() % (rows * columns));
         n1 = cards[p1].getNote();
         n2 = cards[p2].getNote();
         cards[p1].setNote(n2);
         cards[p2].setNote(n1);
      }
      msg("Are you ready?");
      PairCount = 0;
      TryCount  = 0;
      CardStatus[0] = -1;
      CardStatus[1] = -1;
   // J[h̔zuꗗ
      if (DOCOMO_EMU) {
         for (int i = 0; i < rows * columns; i++) {
            System.out.print(cards[i].getNote() + "v");
            if (2 == (i % 3)) System.out.print("\n");
         }
      }
      StartTime = System.currentTimeMillis();
   }

   public MainCanvas(int w, int h) {
      width  = w;
      height = h;

      rnd         = new Random();

      int n = 0;
      cards = new Card[columns * rows   ];
      for (int y = 0; y < rows   ; y++) {
         for (int x = 0; x < columns; x++) {
            cards[n] = new Card(n, n % 6, x, y);
            n++;
         }
      }

      setSoftLabel(Frame.SOFT_KEY_1, "Start");  // measure
      setSoftLabel(Frame.SOFT_KEY_2, "Exit");   // exit

      mimageTitle    = MediaManager.getImage("resource:///title.gif");
      mimageQuestion = MediaManager.getImage("resource:///quistion.gif");
      mimageNote     = MediaManager.getImage("resource:///note.gif");
      try {
          mimageTitle.use();
          mimageQuestion.use();
          mimageNote.use();    
      } catch (ConnectionException ce) {
          // Handle networking problem here
          ce.printStackTrace();
      } catch (UIException uie) {
          // Handle UI problem here
          uie.printStackTrace();
      }

      imageTitle    = mimageTitle.getImage();
      imageQuistion = mimageQuestion.getImage();
      imageNote     = mimageNote.getImage();
   // resetCards();
      // svƂȂMediaManagerB
      mimageTitle    = null;
      mimageQuestion = null;
      mimageNote     = null;
      repaint();
   }

   public void paint(Graphics g) {
      g.lock();
      drawCards(g);
      g.unlock(true);
   }


   private void drawCards(Graphics g) {
      int n      = 0;
      int status = 0;
      int x, y;
      g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
      g.fillRect(  0,  0, getWidth(),getHeight());

      for (int i = 0; i < (columns * rows); i++) {
         status = cards[i].check();
              x = cards[i].getX() * card_width + offsetX;
              y = cards[i].getY() * card_height;
         switch (status) {
            case  -1 : g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
                       g.fillRect(x, y,card_width ,card_height);
                       g.setColor(Graphics.getColorOfRGB(  0,128,  0)); /** Z */
                       g.fillRect(x, y,card_width - 2,card_height -2);
                       g.drawImage(imageQuistion, x + 8, y + 2); // 14x20
                       break;
            case   0 : g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
                       g.fillRect(x, y,card_width ,card_height);
                       g.setColor(Graphics.getColorOfRGB(  0,255, 64)); /**  */
                       g.fillRect(x, y,card_width - 2,card_height -2);
                       g.drawImage(imageNote    , x + 6, y + 2); // 18x20
                       break;
            case   1 : n = cards[i].getNote();
                       String str = "  ";
                       switch (n) {
                          case  1 : str = "do"; break;
                          case  2 : str = "re"; break;
                          case  3 : str = "mi"; break;
                          case  4 : str = "so"; break;
                          case  5 : str = "la"; break;
                       }
                       g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
                       g.fillRect(x, y,card_width ,card_height);
                       if (0 == n) {
                          g.setColor(Graphics.getColorOfRGB(  0,  0,  0)); /** Black */
                          g.fillRect(x, y,card_width-2 ,card_height-2);
                          g.setFont(Font.getFont(Font.FACE_PROPORTIONAL |
                                                 Font.SIZE_SMALL     |
                                                 Font.STYLE_BOLD ));
                          g.setColor(Graphics.getColorOfRGB(255,255,  0)); /** Yellow */
                          g.drawString("r", x + 24, y + 15);
                          g.drawString("e", x + 18, y + 16);
                          g.drawString("k", x + 12, y + 17);
                          g.drawString("o", x +  6, y + 18);
                          g.drawString("J", x     , y + 20);
                       } else {
                          g.setColor(Graphics.getColorOfRGB(  0,  0,255)); /** Blue */
                          g.fillRect(x, y,card_width-2 ,card_height-2);
                          g.setFont(Font.getFont(Font.FACE_MONOSPACE |
                                                 Font.SIZE_LARGE     |
                                                 Font.STYLE_BOLD));
                          g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
                          g.drawString(str, x + 8, y + 16);
                       }
                       break;
         }
      }
      g.setColor(Graphics.getColorOfRGB(  0,  0,255)); /** Blue */
      g.fillRect(0 ,96,120,20);
      g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
      g.setFont(Font.getFont(Font.FACE_MONOSPACE |
                             Font.SIZE_MEDIUM    |
                             Font.STYLE_PLAIN));
      g.drawString(message, 0, 114);
   // System.gc();
      if (TitleFlag == 0) {
         g.setColor(Graphics.getColorOfRGB(255,255,255)); /** White */
         g.fillRect(0 ,0,getWidth(), card_height*3);
         g.drawImage(imageTitle, 0, 0);
         g.setColor(Graphics.getColorOfRGB(  0,  0,255)); /** Blue */
         g.drawString("Copyright(C) triring", 0, 42);
         g.drawString("    2001 - 2002.",     0, 56);
         g.drawString("All rights reserved.", 0, 68);
         TitleFlag++;
         // ^Cg̕\́Cx
         // N̕\ICɍ폜B
          imageTitle = null;
         mimageTitle = null;
      }
      return;
   }

   public void processEvent(int type, int param) {
      int statusGAME = PLAY;
      int i = -1;
      if (type == Display.KEY_PRESSED_EVENT) {
         switch (param) {
            case Display.KEY_SOFT1 : if (runStatus == false) {
                                        setSoftLabel(Frame.SOFT_KEY_1, "New");
                                        resetCards();
                                        repaint();
                                        runStatus = true;         // stO
                                     } else {
                                        setSoftLabel(Frame.SOFT_KEY_1, "Start");
                                        runStatus = false;         // stO
                                     }
                                     return;
            case Display.KEY_SOFT2 : runStatus = false;
                                     IApplication.getCurrentApp().terminate();
                                     break;
            case Display.KEY_1        : i =  0; break;
            case Display.KEY_2        : i =  1; break;
            case Display.KEY_3        : i =  2; break;
            case Display.KEY_4        : i =  3; break;
            case Display.KEY_5        : i =  4; break;
            case Display.KEY_6        : i =  5; break;
            case Display.KEY_7        : i =  6; break;
            case Display.KEY_8        : i =  7; break;
            case Display.KEY_9        : i =  8; break;
            case Display.KEY_ASTERISK : i =  9; break;
            case Display.KEY_0        : i = 10; break;
            case Display.KEY_POUND    : i = 11; break;
            default                   :         break;
         }
         if (runStatus == false) return;
      // if (GameOver  == true ) return;

         int status = cards[i].check();
      // int id     = cards[i].getID();
         int note   = cards[i].getNote();
// if (DOCOMO_EMU) System.out.print("i=" + i + ",status="+status+",note="+note+"\n");
         switch (status) {
            case Card.LISTEN : // 𕷂߂cardJ
            case Card.OPEN   : // āCcardJ
                     Card.playSoundEffects(Card.PIPO);
                     msg("ɁCJĂ܂B");
                     break;
            case Card.CLOSE  : // card͊JĂȂ
                     // ̃J[h2ꍇ
                     if (-1 != CardStatus[1]) {
                        cards[CardStatus[0]].set(Card.CLOSE); // card𗠕Ԃ
                        cards[CardStatus[1]].set(Card.CLOSE); // card𗠕Ԃ
                        // ̃J[hNAB
                        CardStatus[0] = -1; CardStatus[1] = -1;
                     }
                     // ̃J[h1ꍇ
                     if (-1 != CardStatus[0]) {
                        // yAꍇ
                        if (note == cards[CardStatus[0]].getNote()) {
                           cards[i].set(Card.OPEN);
                           cards[CardStatus[0]].set(Card.OPEN);
                           // Joker̃yAꍇ
                           if (0 == note) { // h{
                              statusGAME = OVER;
                           } else {
                              statusGAME = PLAY;
                           }
                           // ̃J[hNAB
                           CardStatus[0] = -1; CardStatus[1] = -1;
                           PairCount++;
                           if (PairCount == 5) {
                              statusGAME = CLEAR;
                           }
                           switch(statusGAME) {
                              case OVER  :
                                       Card.playSoundEffects(Card.SOUSOU);
                                       setSoftLabel(Frame.SOFT_KEY_1, "Start");
                                       runStatus = false;         // stO
                                       dialog = new Dialog(Dialog.DIALOG_INFO,"Five notes");
                                       dialog.setText("Game Over !");
                                       dialog.show();
                                       msg("Game Over !");
                                       Card.stopSoundEffects(Card.SOUSOU);
                                       break;
                              case PLAY  :
                                       cards[i].playNote();
                                       msg("Trying:" + (TryCount / 2) +
                                           "  Pair:" +  PairCount + " / 5");
                                       break;
                              case CLEAR :
                                       Card.playSoundEffects(Card.SPRING);
                                       setSoftLabel(Frame.SOFT_KEY_1, "Start");
                                       runStatus = false;         // stO
                                       dialog = new Dialog(Dialog.DIALOG_INFO,"Five notes");
                                       long time = System.currentTimeMillis() - StartTime;
                                       dialog.setText(
                                           "Congratulations  " +
                                           "Trying:" + (TryCount / 2) + "         " +
                                           "Time  :" + (time / 1000) + 
                                           "." + (time % 1000) + "sec"
                                       );
                                       dialog.show();
                                       msg("Congratulations!");
                                       Card.stopSoundEffects(Card.SPRING);
                                       break;
                           }
                           // gameIꍇ́CׂẴJ[hJČB
                           if (statusGAME != PLAY) {
                              for (int n = 0; n < 12; n++) {
                                 cards[n].set(Card.OPEN);
                              }
                           }
                        } else { // J[hȂꍇ
                           cards[i].playNote();
                           cards[i].set(Card.LISTEN);
                           CardStatus[1] = CardStatus[0];
                           CardStatus[0] = i;
                        }
                     } else { // J[hĂȂꍇ
                        cards[i].playNote();
                        cards[i].set(Card.LISTEN);
                        CardStatus[0] = i; CardStatus[1] = -1;
                     }
                     TryCount++;
                     break;
         }
         repaint();
      }
   }
}
