/*
 * Card.java
 * Author: Akio MIWA, 2002-.
 */

import com.nttdocomo.io.ConnectionException;
import com.nttdocomo.ui.AudioPresenter;
import com.nttdocomo.ui.MediaManager;
import com.nttdocomo.ui.MediaPresenter;
import com.nttdocomo.ui.MediaSound;
import com.nttdocomo.ui.UIException;
import java.util.Random;


/**
 摜ƉǗNX
 */
class Card {
// final static boolean DOCOMO_EMU = false;
// final static boolean DOCOMO_EMU = true;


public final static int CLOSE  = -1; // card͊JĂȂ
public final static int LISTEN =  0; // 𕷂߂cardJ
public final static int OPEN   =  1; // āCcardJ

public final static int PIPO   =  0; // ʉ s|b
public final static int SOUSOU =  1; // ʉ si
public final static int SPRING =  2; // ʉ rofB@lGutv

   int x;               // J[hxʒu
   int y;               // J[hyʒu
   int ID     = 0;
   int note   = 0;
   int Status = CLOSE;  // J[h̏ԂϐB
   int Joker  = 0;      // JokerJ[h̏ԂϐB
// boolean Heads_or_Tails = false;

static AudioPresenter apDO;      // AudioPresenter (to present the MIDI file)
static AudioPresenter apRE;      //
static AudioPresenter apMI;      //
static AudioPresenter apSO;      //
static AudioPresenter apLA;      //
static AudioPresenter apGUNSHOT; //
static AudioPresenter apPIPO;    //
static AudioPresenter apSOUSOU;  //
static AudioPresenter apSPRING;  //

   Card(int id, int n, int x, int y) {
      this.ID   = id;
      this.note = n;
      this.x = x;
      this.y = y;

      // @햼擾
      System.out.println("microedition.platform = " + System.getProperty("microedition.platform"));
      String platform = System.getProperty("microedition.platform");
   // if (DOCOMO_EMU) {
      if (platform.equals("reference")) {
         apDO      = AudioLoader.createAudio("do.mid");
         apRE      = AudioLoader.createAudio("re.mid");
         apMI      = AudioLoader.createAudio("mi.mid");
         apSO      = AudioLoader.createAudio("so.mid");
         apLA      = AudioLoader.createAudio("la.mid");
         apGUNSHOT = AudioLoader.createAudio("gunshut.mid");
         apPIPO    = AudioLoader.createAudio("pipo.mid");
         apSOUSOU  = AudioLoader.createAudio("sousou.mid");
         apSPRING  = AudioLoader.createAudio("spring.mid");
      } else {
         apDO      = AudioLoader.createAudio("do.mld");
         apRE      = AudioLoader.createAudio("re.mld");
         apMI      = AudioLoader.createAudio("mi.mld");
         apSO      = AudioLoader.createAudio("so.mld");
         apLA      = AudioLoader.createAudio("la.mld");
         apGUNSHOT = AudioLoader.createAudio("gunshut.mld");
         apPIPO    = AudioLoader.createAudio("pipo.mld");
         apSOUSOU  = AudioLoader.createAudio("sousou.mld");
         apSPRING  = AudioLoader.createAudio("spring.mld");
      }
   }

   int  countJoker()   { return this.Joker++; }
// int  getID()        { return this.ID;      }
   int  getNote()      { return this.note;    }
   int  getX()         { return this.x;       }
   int  getY()         { return this.y;       }
   void setNote(int n) { this.note = n;       }

   void playNote() {
      switch (this.note) {
         case 0     : apGUNSHOT.play(); break;
         case 1     : apDO.play();      break;
         case 2     : apRE.play();      break;
         case 3     : apMI.play();      break;
         case 4     : apSO.play();      break;
         case 5     : apLA.play();      break;
         default    : apPIPO.play();    break;
      }
   }

   // ʉ̍Đ
static void playSoundEffects(int n) {
      switch (n) {
         case 0     : apPIPO.play();    break;
         case 1     : apSOUSOU.play();  break;
         case 2     : apSPRING.play();  break;
      }
   }

   // ʉ̒~
static void stopSoundEffects(int n) {
      switch (n) {
         case 0     : apPIPO.stop();    break;
         case 1     : apSOUSOU.stop();  break;
         case 2     : apSPRING.stop();  break;
      }
   }

   int set(int s)   { this.Status = s;     return this.Status; }
   int reset()      {
      this.Joker  = 0;            // JokerJ[h̏ԂϐB
      this.note   = 0;
      this.Status = CLOSE;        // J[h̏ԂϐB
      return this.Status; 
   }
   int check()      {                      return this.Status; }

// boolean getStatus(         ) { return this.Heads_or_Tails;           }
// void    setStatus(boolean b) { this.Heads_or_Tails              = b; }
}
